/* Example: reading data from a file */
/* The number of lines in the file is unknown */

#include <stdio.h>
#include <stdlib.h>

#define DATA "class.list"
#define MAX_CLASS 10

int main(void)
{
  FILE *pf;
  char surname[MAX_CLASS][40];
  char forename[MAX_CLASS][40];
  int mark[MAX_CLASS];
  int s, lines;

  pf = fopen(DATA, "r");  /* open file to read */
  if (pf == NULL)
  {
    fprintf(stderr, "Error: couldn't open file %s\n", DATA);
    exit(EXIT_FAILURE);
  }

  /* read data from the file: */
  
  for (s = 0; !feof(pf); s++) /* stop at end of file */
  {
    if (s >= MAX_CLASS)
    {
      fputs("Error: too many lines in file\n", stderr);
      exit(EXIT_FAILURE);
    }
    fscanf(pf, "%s %s %i", &surname[s], &forename[s], &mark[s]);
  }
  lines = s - 1;
  fclose(pf);
  
  /* print data to stdout: */
  
  for (s = 0; s < lines; s++)
    printf("%s %s got %i%%\n", forename[s], surname[s], mark[s]);

  return EXIT_SUCCESS;
}
